## ros-kinetic-eml 1.8.15

=== eml-svn/CMakeLists.txt ===
# Copyright FMTC 2006-2008
# Author: Klaas Gadeyne.  Copied stuff from <http://cmake.org/HTML/Examples.html>
# Linux (PREEMPT_RT) port based on patch by RvdM (October, 5th, 2007)

# The name of our project is "EML" (EtherCat Master Library).
# CMakeLists files in this project can refer to the root source
# directory of the project as ${EML_SOURCE_DIR} and
# to the root binary directory of the project as ${EML_BINARY_DIR}.
project (EML)

OPTION( BUILD_FOR_ECOS "Build EML for the eCos OS" OFF)

IF (BUILD_FOR_ECOS)
   INCLUDE(UseEcos)
   SET( ECOS_INSTALL_PATH "/path/to/ecos.ecc file" CACHE STRING "Where are your ecos installation directories (i.e. your ecos.ecc file)?" )
   # ECOS_ADD_INCLUDE_DIRECTORIES()
   INCLUDE_DIRECTORIES(${EML_SOURCE_DIR}/include/ethercat/arch-eCos)
   INCLUDE_DIRECTORIES(${ECOS_INSTALL_PATH}/ecos/install/include/)
   # FIXME: Build system only supports i386 for now...
   ECOS_USE_I386_ELF_TOOLS()
ENDIF (BUILD_FOR_ECOS)

OPTION( BUILD_FOR_RTNET "Build EML using RTNET/Xenomai" ON)

IF (BUILD_FOR_RTNET)
	SET(CMAKE_VERBOSE_MAKEFILE ON)
	SET(RTNET_INSTALL_PATH "/usr/local/rtnet" CACHE STRING "Path of the RTnet installation directory")
	SET(XENOMAI_INSTALL_PATH "/usr/xenomai" CACHE STRING "Path of the Xenomai installation directory")

	INCLUDE_DIRECTORIES(${EML_SOURCE_DIR}/include/ethercat/arch-RTnet)
	INCLUDE_DIRECTORIES(${RTNET_INSTALL_PATH}/include)
	INCLUDE_DIRECTORIES(${XENOMAI_INSTALL_PATH}/include)
	LINK_DIRECTORIES(${XENOMAI_INSTALL_PATH}/lib)

	SET (XNPOSIX_USER_CFLAGS "`${XENOMAI_INSTALL_PATH}/bin/xeno-config --posix-cflags`")
	EXEC_PROGRAM ("${XENOMAI_INSTALL_PATH}/bin/xeno-config --posix-ldflags"
	  OUTPUT_VARIABLE XNPOSIX_USER_LDFLAGS)
ENDIF (BUILD_FOR_RTNET)

OPTION( BUILD_FOR_POSIX "Build for POSIX (Only tested on Linux/PREEMPT_RT for now)" OFF)

IF (BUILD_FOR_POSIX)
        SET (POSIX_USER_LDFLAGS "-lpthread")

	INCLUDE_DIRECTORIES(${EML_SOURCE_DIR}/include/ethercat/arch-RTnet)

ENDIF (BUILD_FOR_POSIX)

# Make sure the compiler can find include files from our library.
include_directories (${EML_SOURCE_DIR}/include)

# This simply branches into the listed subdirectories Recurse into the
# "src" and "test" subdirectories.  This does not actually cause
# another cmake executable to run.  The same process will walk through
# the project's entire directory structure.
add_subdirectory (src)
add_subdirectory (tests)

# FIXME KG What's the f*cking difference with SUBDIRS, as used in the
# ecos examples?
# SUBDIRS(src tests)

=== eml-svn/src/CMakeLists.txt ===
FILE( GLOB SRCS al/[^.]*.cxx dll/[^.]*.cxx )
SET (eml_SRCS ${SRCS})

IF (BUILD_FOR_ECOS)
  # Copied some stuff from ECOS_ADD_EXECUTABLE macro, since there is no
  # ECOS_ADD_LIBRARY call
  ADD_DEFINITIONS(-D__ECOS__=1 -D__ECOS=1)
  SET(ECOS_DEFINITIONS -Wall -Wno-long-long -pipe -fno-builtin)

  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wstrict-prototypes")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Woverloaded-virtual -fno-rtti -Wctor-dtor-privacy -fno-strict-aliasing -fno-exceptions")
  
  # eCos only supports static libraries
  add_library(eml ${eml_SRCS})
  
  # arch specific headers
  FILE( GLOB ARCH_INCLS ${EML_SOURCE_DIR}/include/ethercat/arch-eCos/ethercat/[^.]*.h )
  INSTALL_FILES( /include/ethercat/arch-eCos/ FILES ${ETHERCAT_INCLS})
ENDIF (BUILD_FOR_ECOS)

IF (BUILD_FOR_RTNET)
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${XNPOSIX_USER_CFLAGS}")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

  FILE( GLOB RTnet_SRCS arch/RTnet/[^.]*.c)
  SET (eml_SRCS "${eml_SRCS};${RTnet_SRCS}")
  
  # Settings for building a static library (.a)
  OPTION(BUILD_STATIC "Build EML as a static library." OFF)
  IF ( BUILD_STATIC )
    ADD_LIBRARY(eml-static STATIC ${eml_SRCS})
    SET_TARGET_PROPERTIES(eml-static
      PROPERTIES OUTPUT_NAME eml LINK_FLAGS "${XNPOSIX_USER_LDFLAGS}"
      CLEAN_DIRECT_OUTPUT 1)
    INSTALL_TARGETS(/lib eml-static)
  ENDIF ( BUILD_STATIC )

  # Settings for building a dynamic library (.so/.dll)
  OPTION(BUILD_DYNAMIC "Build EML as a dynamic library (Default)." ON)
  IF( BUILD_DYNAMIC)
    ADD_LIBRARY(eml-dynamic SHARED ${eml_SRCS})
    SET_TARGET_PROPERTIES(eml-dynamic
      PROPERTIES OUTPUT_NAME eml LINK_FLAGS "${XNPOSIX_USER_LDFLAGS}"
      CLEAN_DIRECT_OUTPUT 1)
    INSTALL_TARGETS(/lib eml-dynamic)
  ENDIF (BUILD_DYNAMIC)

  # arch specific headers
  FILE( GLOB ARCH_RTNET_INCLS ${EML_SOURCE_DIR}/include/ethercat/arch-RTnet/ethercat/[^.]*.h )
  INSTALL_FILES( /include/ethercat/arch-RTnet/ FILES ${ARCH_RTNET_INCLS})

ENDIF(BUILD_FOR_RTNET)

IF (BUILD_FOR_POSIX)

  FILE( GLOB posix_SRCS arch/posix/[^.]*.c)
  SET (eml_SRCS "${eml_SRCS};${posix_SRCS}")
  
  # Settings for building a static library (.a)
  OPTION(BUILD_STATIC "Build EML as a static library." OFF)
  IF ( BUILD_STATIC )
    ADD_LIBRARY(eml-static STATIC ${eml_SRCS})
    SET_TARGET_PROPERTIES(eml-static
      PROPERTIES OUTPUT_NAME eml LINK_FLAGS "${POSIX_USER_LDFLAGS}"
      CLEAN_DIRECT_OUTPUT 1)
    INSTALL_TARGETS(/lib eml-static)
  ENDIF ( BUILD_STATIC )

  # Settings for building a dynamic library (.so/.dll)
  OPTION(BUILD_DYNAMIC "Build EML as a dynamic library (Default)." ON)
  IF( BUILD_DYNAMIC)
    ADD_LIBRARY(eml-dynamic SHARED ${eml_SRCS})
    SET_TARGET_PROPERTIES(eml-dynamic
      PROPERTIES OUTPUT_NAME eml LINK_FLAGS "${POSIX_USER_LDFLAGS}"
      CLEAN_DIRECT_OUTPUT 1)
    INSTALL_TARGETS(/lib eml-dynamic)
  ENDIF (BUILD_DYNAMIC)

  # arch specific headers
  FILE( GLOB ARCH_POSIX_INCLS ${EML_SOURCE_DIR}/include/ethercat/arch-RTnet/ethercat/[^.]*.h )
  INSTALL_FILES( /include/ethercat/arch-RTnet/ FILES ${ARCH_POSIX_INCLS})

ENDIF(BUILD_FOR_POSIX)


# Also install header files
FILE( GLOB AL_INCLS ${EML_SOURCE_DIR}/include/al/[^.]*.h )
INSTALL_FILES( /include/al/ FILES ${AL_INCLS})
FILE( GLOB DLL_INCLS ${EML_SOURCE_DIR}/include/dll/[^.]*.h )
INSTALL_FILES( /include/dll/ FILES ${DLL_INCLS})
FILE( GLOB ETHERCAT_INCLS ${EML_SOURCE_DIR}/include/ethercat/[^.]*.h )
INSTALL_FILES( /include/ethercat/ FILES ${ETHERCAT_INCLS})

=== eml-svn/tests/posix/CMakeLists.txt ===
SET (CMAKE_C_FLAGS "${CMAKE_CFLAGS} ${XNPOSIX_USER_CFLAGS}")
SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
ADD_EXECUTABLE(master_test master_test.cpp)
TARGET_LINK_LIBRARIES(master_test eml)
# removed eval_test
#ADD_EXECUTABLE(eval_test eval_test.cpp process_data.cpp)
#TARGET_LINK_LIBRARIES(eval_test eml)
SET_TARGET_PROPERTIES(master_test PROPERTIES LINK_FLAGS "${POSIX_USER_LDFLAGS}")

=== debian/changelog ===
ros-kinetic-eml (1.8.15-6xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- David Feil-Seifer <dave@cse.unr.edu>  Mon, 09 Apr 2018 03:53:31 -0000

=== debian/control ===
Source: ros-kinetic-eml
Section: misc
Priority: extra
Maintainer: David Feil-Seifer <dave@cse.unr.edu>
Build-Depends: debhelper (>= 9.0.0), cmake
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-eml
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-catkin
Description: This is an implementation of the EtherCAT master protocol for the PR2 robot based on the work done at Flanders' Mechatronics Technology Centre.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-eml//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
